// 2 (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[11];
	int i,d;

	struct fpos md[] =
	{
		{ 0x09, 0x01, 0x0500 },	// 00
		{ 0x09, 0x06, 0x0500 },	// 01
		{ 0x09, 0x0b, 0x0500 },	// 02
		{ 0x0a, 0x01, 0x0600 },	// 03
		{ 0x0a, 0x07, 0x0300 },	// 04
		{ 0x0a, 0x0a, 0x0500 },	// 05
		{ 0x0a, 0x0f, 0x0300 },	// 06
		{ 0x0b, 0x02, 0x0800 },	// 07
		{ 0x0b, 0x0a, 0x0200 },	// 08
		{ 0x0b, 0x0c, 0x0200 },	// 09
		{ 0x0b, 0x0e, 0x0400 },	// 10
		{ 0x0c, 0x02, 0x0400 },	// 11
		{ 0x0c, 0x06, 0x0500 },	// 12
		{ 0x0c, 0x0b, 0x0300 },	// 13
		{ 0x0c, 0x0e, 0x0600 },	// 14
		{ 0x0d, 0x04, 0x0600 },	// 15
		{ 0x0d, 0x0a, 0x0500 },	// 16
		{ 0x0d, 0x0f, 0x0700 },	// 17
		{ 0x0e, 0x06, 0x0400 },	// 18
		{ 0x0e, 0x0a, 0x0400 },	// 19
		{ 0x0e, 0x0e, 0x0200 },	// 20
		{ 0x0f, 0x01, 0x0600 },	// 21
		{ 0x0f, 0x07, 0x0500 },	// 22
		{ 0x0f, 0x0c, 0x0700 },	// 23
		{ 0x10, 0x03, 0x0200 },	// 24
		{ 0x10, 0x05, 0x0100 },	// 25
		{ 0x10, 0x06, 0x0200 },	// 26
		{ 0x10, 0x08, 0x0200 },	// 27
		{ 0x10, 0x0a, 0x0200 },	// 28
		{ 0x10, 0x0c, 0x0100 },	// 29
		{ 0x10, 0x0d, 0x0200 },	// 30
		{ 0x10, 0x0f, 0x0200 },	// 31
		{ 0x11, 0x01, 0x0100 },	// 32
		{ 0x11, 0x02, 0x0500 },	// 33
		{ 0x11, 0x07, 0x0800 },	// 34
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x100);
		switch (buff[0x02])
		{
		case 0x00:
			printf("Disk 1 F܂.\n");
			fcut("PROG", 0x01, 0x00, 0x01, 0x01, 0x01, 0x0000, 0x1e00);
			for (i=0; md[i].sec; i++)
			{
				sprintf(fname,"MUS%02d",i);
				fcut(fname, md[i].trk, md[i].trk>>1, md[i].trk&1, md[i].sec, 0x01, 0x0000, md[i].size);
			}
			continue;

		case 0x01:
			printf("Disk 2 F܂.\n");
			continue;
			
		case 0x02:
			printf("Disk 3 F܂.\n");
			continue;
			
		case 0x03:
			printf("Disk 4 F܂.\n");
			continue;
		}
		printf("FłȂfBXNł.\n");
	}
	return 0;
}

